function fxDtsBrick::FireAtBrick(%this,%datablock,%string,%mod,%vec,%client)
{
	%target = findbrickbyname(%string,%client);
	if(!isObject(%target))
		return -1;

	%targetpos = %target.position;
	%initialpos = %this.position;

	%x = getword(%targetpos,0) - getword(%initialpos,0);
	%y = getword(%targetpos,1) - getword(%initialpos,1);
	%z = getword(%targetpos,2) - getword(%initialpos,2);

	%x *= %mod;
	%y *= %mod;
	%z *= %mod;

	%rx = getrandom(0-getword(%vec,0),getword(%vec,0));
	%ry = getrandom(0-getword(%vec,1),getword(%vec,1));
	%rz = getrandom(0-getword(%vec,2),getword(%vec,2));

	%x += %rx;
	%y += %ry;
	%z += %rz;	
	
	%p = new Projectile()
	{
		datablock = %datablock;
		initialPosition = %this.getTransform();
		client = %client;
		initialVelocity = %x SPC %y SPC %z;
	};
	MissionCleanup.add(%p);
	return %p;
}

function fxDtsBrick::FireAtClosestPlayer(%this,%datablock,%mod,%vec,%max,%client)
{
	%target = findclosestplayerpos(%this.position).player;
	if(!isObject(%target))
		return -1;

	%targetpos = %target.position;
	%initialpos = %this.position;

	%x = getword(%targetpos,0) - getword(%initialpos,0);
	%y = getword(%targetpos,1) - getword(%initialpos,1);
	%z = getword(%targetpos,2) - getword(%initialpos,2);

	if(mAbs(%x)+mAbs(%y)+mAbs(%z) > %max)
		return -1;

	%x *= %mod;
	%y *= %mod;
	%z *= %mod;

	%rx = getrandom(0-getword(%vec,0),getword(%vec,0));
	%ry = getrandom(0-getword(%vec,1),getword(%vec,1));
	%rz = getrandom(0-getword(%vec,2),getword(%vec,2));

	%x += %rx;
	%y += %ry;
	%z += %rz;	
	
	%p = new Projectile()
	{
		datablock = %datablock;
		initialPosition = %this.getTransform();
		client = %client;
		initialVelocity = %x SPC %y SPC %z;
	};
	MissionCleanup.add(%p);
	return %p;
}

function findclosestplayerpos(%pos)
{
	%minpos = -1;
	%play = -1;
	for(%a=0;%a<clientgroup.getcount();%a++)
	{
		%tpos = clientgroup.getobject(%a).player.position;
		%xdist = mAbs(getword(%pos,0)-getword(%tpos,0));
		%ydist = mAbs(getword(%pos,1)-getword(%tpos,1));
		%zdist = mAbs(getword(%pos,2)-getword(%tpos,2));
		%dist = %xdist+%ydist+%zdist;
		if(%minpos == -1)
		{
			%minpos = %dist;
			%play = clientgroup.getobject(%a);
		}
		if(%minpos > %dist)
		{
			%minpos = %dist;
			%play = clientgroup.getobject(%a);
		}
	}
	return %play;
}

function findbrickbyname(%name,%cl)
{
	if(!isObject(%cl))
		return -1;
	for(%a=0;%a<%cl.brickgroup.getcount();%a++)
	{
		%qname = %cl.brickgroup.getobject(%a).getname();
		%qname = trim(%qname);
		%qname = strreplace(%qname,"_"," ");
		%qname = trim(%qname);
		%name = trim(%name);
		if(%qname $= %name)
			return %cl.brickgroup.getobject(%a);
	}
}

registerOutputEvent(fxDtsBrick,"FireAtBrick","datablock projectiledata\tstring 20 20\tfloat 0.1 10 0.1 1\tvector",1);
registerOutputEvent(fxDtsBrick,"FireAtClosestPlayer","datablock projectiledata\tfloat 0.1 10 0.1 1\tvector\tfloat 10 250 5 75",1);